<?php

require __DIR__ . '/vendor/autoload.php';

use Google\Client;
use Google\Service\Gmail;

function getClient(){
    
    $client = new Client();
    $client->setApplicationName('Gmail API PHP Quickstart');
    $client->setScopes('https://www.googleapis.com/auth/gmail.modify');
    $client->setAuthConfig('client_secret.json');
    $client->setAccessType('offline');
    $client->setPrompt('select_account consent');
    $tokenPath = 'Token.json';
    
    echo "<pre>";
    print_r($client);
    die();
    
    if (file_exists($tokenPath)) {
        $accessToken = json_decode(file_get_contents($tokenPath), true);
        $client->setAccessToken($accessToken);
    }

    if ($client->isAccessTokenExpired()) {
        if ($client->getRefreshToken()) {
            $client->fetchAccessTokenWithRefreshToken($client->getRefreshToken());
        } else {
            $authCode = "";
            if(isset($_GET['code'])){
                $authCode = trim($_GET['code']);
            }else{
              $authUrl = $client->createAuthUrl();
              
              printf("Open the following link in your browser:\n%s\n", $authUrl);
              print 'Enter verification code: ';
              
              $authCode = trim(fgets(STDIN));
    
              $accessToken = $client->fetchAccessTokenWithAuthCode($authCode);
              $client->setAccessToken($accessToken);
            }
            
            $accessToken = $client->fetchAccessTokenWithAuthCode($authCode);
            $client->setAccessToken($accessToken);
            
        }
        if (!file_exists(dirname($tokenPath))) {
            mkdir(dirname($tokenPath), 0700, true);
        }
        file_put_contents($tokenPath, json_encode($client->getAccessToken()));
    }
    return $client;
}


try{
    
    $client = getClient();
    $service = new Gmail($client);
    $message = new Google_Service_Gmail_Message();
    
    $json = file_get_contents('php://input');
    $post = json_decode($json,1);
    
    $from_name = $post['website_name'] ? $post['website_name'] : "Enquiry";
    $send_to = $post['send_to'] ? $post['send_to'] : "";
    $message_body = $post['message_body'] ? $post['message_body'] : "";
    $subject = $post['subject'] ? $post['subject'] : "";
    
    $sendEmails = explode(",",$send_to);
    $toEmail = "";
    if(!empty($sendEmails)){
        foreach($sendEmails as $sendEmail){
            $toEmail .= "To: <".trim($sendEmail).">\r\n";
        }
    }
    
    $rawMessageString = "From: ".$from_name." <noreply.webdf@gmail.com>\r\n";
    $rawMessageString .= $toEmail;
    $rawMessageString .= 'Subject: =?utf-8?B?' . base64_encode($subject) . "?=\r\n";
    $rawMessageString .= "MIME-Version: 1.0\r\n";
    $rawMessageString .= "Content-type:text/html;charset=UTF-8\r\n";
    $rawMessageString .= 'Content-Transfer-Encoding: binary' . "\r\n\r\n";
    $rawMessageString .= "{$message_body}\r\n";
    $rawMessage = strtr(base64_encode($rawMessageString), array('+' => '-', '/' => '_'));
    $message->setRaw($rawMessage);
    $message = $service->users_messages->send('noreply.webdf@gmail.com', $message);
    print '1';
}


catch(Exception $e) {
    echo 'Message: ' .$e->getMessage();
    return true;
}


?>